package FreqPolygon;

import java.io.*;
import javafx.application.Application;
import javafx.scene.*;
import javafx.scene.chart.*;
import javafx.scene.layout.*;
import javafx.stage.*;

public class FreqPolygon extends Application {

	@Override
	public void start(Stage stage){
			int n_intvl = 0;
			double x_value[] = {};
			int IntvlFreq[] = {};			
			String VarLabel = "";
			try{
				//
				//				L[{[h͂obt@[tŐݒ
				//
				BufferedReader cin = new BufferedReader( new InputStreamReader(System.in) );
				System.out.print("Input Data File = ");
				//
				//			̓f[^t@C̐ݒ
				//
				String fin_nm = cin.readLine();
				BufferedReader fin = new BufferedReader( new FileReader(fin_nm));
				//
				//			o͗peLXgt@C̐ݒ
				//
				System.out.print("Output File Name = ");
				String fout_nm = cin.readLine();
				PrintWriter fout = new PrintWriter( new BufferedWriter( new FileWriter(fout_nm)));
				
				double data[] = new double[10000];			//		f[^i[pz
										
				int n = 0;
				while(true){
					String s = fin.readLine();
					if(s.length() > 0)
						if (s.charAt(0) == '/')				//		XbV / Ŏn܂s܂œǂݐi
							break;
				}
				VarLabel = fin.readLine();				//		ϐ̓ǂݍ
				while(true){
					String s = fin.readLine();
					if (s.charAt(0) == '/') break;		//		XbV / Ŏn܂sœǂݍ݂̏I
					data[n++] = Double.parseDouble(s);
				}
				fin.close();							//		̓Xg[

				double minX = data[0], maxX = data[0];
				fout.println("Data...");
				for (int i = 0; i < n; i++){
					//
					//		ǂݍ񂾃f[^̊mFpo
					//
					System.out.println("data[" + (i + 1) + "] = " + data[i]);
					fout.println("data[" + (i + 1) + "] = " + data[i]);
					//
					//		ŏlAől߂
					//
					if (minX > data[i]) minX = data[i];
					if (maxX < data[i]) maxX = data[i];
				}
				fout.println();
				fout.println("min = " + minX + "    max = " + maxX);
				System.out.println("\nmin = " + minX + "    max = " + maxX);
				double LB;		//		xz̍[̒l
				double UB;		//		xz̉E[̒l
				while(true){
					System.out.print("Lower Boundary Value = ");
					LB = Double.parseDouble(cin.readLine());
					System.out.print("Upper Boundary Value = ");
					UB = Double.parseDouble(cin.readLine());
					if ((LB < minX) &&  (UB > maxX)) break;
					System.out.println("LB or UB  is not valid.");
				}
				System.out.print("Number of intervals = ");
				n_intvl = Integer.parseInt(cin.readLine());		//		xz̊K
				double w_intvl = (UB - LB) / n_intvl;			//		K̋Ԃ̕
				n_intvl += 2;									//		[ɓxŐԂǉ
				x_value = new double[n_intvl];
				for (int i = 0; i < n_intvl; i++){
					x_value[i] = LB - (0.5 * w_intvl) + i * w_intvl;			//		K̋Ԃ̒l
					System.out.println("x_value[" + i + "] = " + x_value[i]);
				} 
				double cx_value[] = new double[n_intvl - 1];
				for (int i = 0; i < n_intvl - 1; i++){
					cx_value[i] = x_value[i] + 0.5 * w_intvl;				//		K̋El
					System.out.println("cx_value[" + i + "] = " + cx_value[i]);
				}
				//
				//			K̓x𐔂
				//
				IntvlFreq = new int[n_intvl];
				for (int i = 0; i < n_intvl; i++)
					IntvlFreq[i] = 0;
				for (int i = 0; i < n; i++){
					int id = 0;
					while((data[i] > cx_value[id]) && (id < (n_intvl - 1))) id++;
					if (data[i] > cx_value[id]) id++;
					IntvlFreq[id]++;					//		f[^̏K̓xP₷
				}
				System.out.println();
				fout.println();
				int sum = 0;
				for (int i = 0; i < n_intvl; i++){
					System.out.println("IntvlFreq[" + i + "] = " + IntvlFreq[i]);
					fout.println("IntvlFreq[" + i + "] = " + IntvlFreq[i]);
					sum += IntvlFreq[i];
				}
				System.out.println("sum = " + sum);
				
				fout.close();				//		o̓t@Ciobt@[̏oj
			}
			catch(Exception e){
				System.out.println("Exception..." + e);
				System.exit(1);
			}

		/*---------------------------------------------------

						xp`̕`

		-----------------------------------------------------*/

		stage.setTitle("xp`");

		NumberAxis x_axis = new NumberAxis();
		x_axis.setLabel("K̒l");
		NumberAxis y_axis = new NumberAxis();
		y_axis.setLabel("x@");

		XYChart.Series<Number, Number> xy_series = new XYChart.Series<>();
		xy_series.setName("K̓x");
		for (int i = 0; i < n_intvl; i++)
			xy_series.getData().add(new XYChart.Data<>(x_value[i], IntvlFreq[i]));
			
		LineChart<Number, Number> freqPoly = new LineChart<>(x_axis, y_axis);
		freqPoly.setTitle(VarLabel + "̓xp`");
		freqPoly.getData().add(xy_series);

		HBox root = new HBox();
		root.getChildren().add(freqPoly);
		stage.setScene( new Scene(root, 800, 600) );
		stage.show();
	}

}